#include <DHT_U.h>
#include "DHT.h" 
#define DHTPIN 3    
#define DHTTYPE DHT11    
DHT dht(DHTPIN, DHTTYPE); 
//luftfeuchtigkeit//

#include <Wire.h>
#include <Adafruit_MLX90614.h>
Adafruit_MLX90614 mlx = Adafruit_MLX90614();


int trigger = 7; //Trigger-Pin des Ultraschallsensors an Pin7 des Arduino-Boards
int echo = 9; // Echo-Pim des Ultraschallsensors an Pin6 des Arduino-Boards
int stepPin1 = 5;// Step-Pin für Stepper 1
int richtungPin1 = 4;// Richtungs-Pin für Stepper 1
int stepPin2 = 12;// Step-Pin für Stepper 2
int richtungPin2 = 11;// Richtungs-Pin für Stepper 2
int LEDr =10;
int LEDl =6;

void setup() {
  mlx.begin();
  Serial.begin (9600); //Serielle kommunikation starten, damit man sich später evtl. die Werte am Serial monitor ansehen kann.
  pinMode(trigger, OUTPUT); 
  pinMode(echo, INPUT);
  
  //Rad links
  pinMode(stepPin1, OUTPUT); 
  pinMode(richtungPin1, OUTPUT); 
  //Rad rechts
  pinMode(stepPin2, OUTPUT); 
  pinMode(richtungPin2, OUTPUT); 

  pinMode(8, OUTPUT); //Verbindungsstelle zu Arduino-Nano 2 & 3

  pinMode(LEDr, OUTPUT); //Pin für gelbe LED (rechts)
  pinMode(LEDl, OUTPUT); //Pin für gelbe LED (links)

  pinMode(A4, INPUT); //SDA-Pin des Wärmesensors (MLX90614)
  pinMode(A5, INPUT); //SCL-Pin des Wärmesensors (MLX90614)

  pinMode(2, OUTPUT); //Pin für rote LED

  dht.begin();


}


void loop() { //der Code bis Z. 69 ist für das Messen der Feuchtigkeits-und Temperaturwerte zuständig, danach ist die räumliche Orientierung festgelegt

  int ptRechts = analogRead (A0);//Phototransistor 1 auf rechter Seite
  int ptLinks = analogRead (A1); //Phototransistor 2 auf linker Seite
  
  double temp = mlx.readObjectTempC();
  if (temp > 22.00) {  //wenn die Temperatur über 35 Grad Celsius beträgt, dann wird auch die Feuchtigkeit gemessen
    digitalWrite(2, HIGH);
      while (true){
      delay(2000);
      for(int i = 0; i < 10; i++){
      nachVorne();}
      float Luftfeuchtigkeit = dht.readHumidity();
      if (Luftfeuchtigkeit > 42.00) { //wenn die Luftfeuchtigkeit über 42% beträgt, aktiviert sich die Melodie (Pin 8) 
             digitalWrite(8, HIGH);  //und der Roboter befindet sich in einer endlosen Schleife, in der er nichts tut
         while (true) {
           
         }
      }
//   if (Luftfeuchtigkeit < 42.00) {
//    break;
//   }
 }
 }

  

  if (entfernungmessen() > 10) { //wenn der Roboter kein Hinderniss vor sich hat, dass weniger als 10cm entfernt ist, wird sich am Licht orientiert
    if (ptLinks > ptRechts + 30) { // für eine flüssige Bewegung fährt der Roboter nur nach links, wenn der Pt links einen um 30 höhren Wert als der Pt rechts misst.
           nachLinks();            //Dies dient der flüssigeren Orientierung. 
   
    }
    else if (ptRechts > ptLinks + 30) {
      nachRechts();
    }
    else if ((ptLinks <= ptRechts + 30) && (ptLinks >= ptRechts - 30)) { //Der Roboter fährt nach Vorne, sollten die gemessen Werte ungefähr gleich sein(+-30)
      nachVorne();

    }

  }
  else { //ist der Roboter 10 oder weniger Zentimeter von einem Hinderniss entfernt, dreht er nach rechts.
    ausweichen();


  }

}


long entfernungmessen() {
  digitalWrite(trigger, LOW);
  delay(5);
  digitalWrite(trigger, HIGH);
  delay(10);
  digitalWrite(trigger, LOW);
long  dauer = pulseIn(echo, HIGH);
long entfernung = (dauer / 2) * 0.03432; //Berechnung der Entfernung mit Hilfe der Geschwindigkeit des Schalls
return entfernung;
}

void nachVorne() {
  digitalWrite(richtungPin1, HIGH);
  digitalWrite(richtungPin2, HIGH);


  digitalWrite(LEDr, HIGH);
  digitalWrite(LEDl, HIGH);

  digitalWrite(stepPin1, HIGH);
  digitalWrite(stepPin2, HIGH);
  delay(10);
  digitalWrite(stepPin1, LOW);
  digitalWrite(stepPin2, LOW);

}

void nachRechts() {
  digitalWrite(richtungPin1, HIGH);
  digitalWrite(richtungPin2, LOW);

  digitalWrite(LEDl, HIGH);
  digitalWrite(LEDr, LOW);

  digitalWrite(stepPin1, HIGH);
  digitalWrite(stepPin2, HIGH);
  delay(10);
  digitalWrite(stepPin1, LOW);
  digitalWrite(stepPin2, LOW);


}
void ausweichen() {
  digitalWrite(richtungPin1, HIGH);
  digitalWrite(richtungPin2, LOW);
  for (int stepCounter = 0; stepCounter < 50; stepCounter++) {
    digitalWrite(stepPin1, HIGH);
    digitalWrite(stepPin2, HIGH);
    delay(10);
    digitalWrite(stepPin1, LOW);
    digitalWrite(stepPin2, LOW);

  }
}
void nachLinks() {
  digitalWrite(richtungPin1, LOW);
  digitalWrite(richtungPin2, HIGH);

  digitalWrite(LEDl, LOW);
  digitalWrite(LEDr, HIGH);

  digitalWrite(stepPin1, HIGH);
  digitalWrite(stepPin2, HIGH);
  delay(10);
  digitalWrite(stepPin1, LOW);
  digitalWrite(stepPin2, LOW);

}

void nachHinten() {
  digitalWrite(stepPin1, HIGH);
  digitalWrite(richtungPin1, LOW);
  digitalWrite(stepPin2, HIGH);
  digitalWrite(richtungPin2, LOW);
}
