
#define NOTE_C2  65
#define NOTE_C4  262  // Definieren der beiden Noten, die für die tieferen Töne gebraucht werden


#include <Servo.h>   // Einbeziehen der Servo-Bibliothek, Servo-Motor für die Samenausgabe


int melodie[] = {
    NOTE_C2,     0, NOTE_C2, 0, NOTE_C2, NOTE_C4, NOTE_C4, 0, 0, 0, 0, 0, 0, 0, 0, 
};  // Notenabfolge in der Melodie


int notenwerte[] = {
 1, 1, 1, 8, 4, 4, 3/2, 4, 4, 4, 4, 4, 4, 4, 5/2,
  
};  // Notenwerte

int melodiepin = 9;
Servo derServo;

void setup() {
    derServo.attach(2);      // Servo an Pin (2) angeschlossen     
    derServo.write(80); 
    delay(600);
    derServo.write(30);     // 50° Drehung zur Öffnung der Vorrichtung zur Samenausgabe


    
  for (int thisNote = 0; thisNote < 15; thisNote++) {

    int notenwert = 1000 / notenwerte[thisNote];     //Berechnung der Notendauer für die einzelnen, nacheinander kommenden Noten
    tone(melodiepin, melodie[thisNote], notenwert);  // tone-Funktion, durch die die Töne nacheinander mit dem jeweiligen zugeordneten Wert abgespielt werden

    
    int pause = notenwert * 1.30;
    delay(pause);                        // Pausen zwischen den Noten, Wert übernommen
  
    noTone(melodiepin);
  }

}

void loop() {
  // die Melodie muss nicht mehrmals abgespielt werden, deshalb steht sie nicht im loop
}
